# No ICE candidates gathered bug

This project contains a reproducible case of Firefox not generating ICE candidates when using fake streams and hosting on localhost. This is quite common when developing e2e tests locally.

I have been able to reproduce this bug with Firefox 81.0.2.

## How to test
First and foremost, make sure you have Node >=12 installed and NPM >=6.13x.

1. Open a terminal and run `npm ci`, this ensures you get the exact versions in the package-lock.json file
2. Run `npm start`
3. Observe that an instance of Firefox is opened, and the page navigates to localhost:8000. The source of the code is in `./app`
4. Click the "Start" button, observe a fake stream being added and shown in the local video frame
5. Click "Call". Observe that no connection is made
6. Navigate to about:webrtc and check out the connection logs. See that there is an INternal error in the UDPSocketParent:

```
insert 'ice' (registry) succeeded: ice

insert 'ice.pref' (registry) succeeded: ice.pref

insert 'ice.pref.type' (registry) succeeded: ice.pref.type

insert 'ice.pref.type.srv_rflx' (UCHAR) succeeded: 0x64

insert 'ice.pref.type.peer_rflx' (UCHAR) succeeded: 0x6e

insert 'ice.pref.type.host' (UCHAR) succeeded: 0x7e

insert 'ice.pref.type.relayed' (UCHAR) succeeded: 0x05

insert 'ice.pref.type.srv_rflx_tcp' (UCHAR) succeeded: 0x63

insert 'ice.pref.type.peer_rflx_tcp' (UCHAR) succeeded: 0x6d

insert 'ice.pref.type.host_tcp' (UCHAR) succeeded: 0x7d

insert 'ice.pref.type.relayed_tcp' (UCHAR) succeeded: 0x00

insert 'stun' (registry) succeeded: stun

insert 'stun.client' (registry) succeeded: stun.client

insert 'stun.client.maximum_transmits' (UINT4) succeeded: 7

insert 'ice.trickle_grace_period' (UINT4) succeeded: 5000

insert 'ice.tcp' (registry) succeeded: ice.tcp

insert 'ice.tcp.so_sock_count' (INT4) succeeded: 0

insert 'ice.tcp.listen_backlog' (INT4) succeeded: 10

insert 'ice.tcp.disable' (char) succeeded: \000

insert 'ice.forced_interface_name' (string) succeeded:

UDP socket error:Internal error at /builds/worker/checkouts/gecko/dom/network/UDPSocketParent.cpp:248 this=0x111f39800

ICE(PC:1603192415299233 (id=4294967299 url=http://localhost:8000/)): failed to find default addresses

getifaddrs error e = 1

UDP socket error:Internal error at /builds/worker/checkouts/gecko/dom/network/UDPSocketParent.cpp:248 this=0x111f39800

ICE(PC:1603192415301092 (id=4294967299 url=http://localhost:8000/)): failed to find default addresses

getifaddrs error e = 1

ICE(PC:1603192415301092 (id=4294967299 url=http://localhost:8000/)): peer (PC:1603192415301092 (id=4294967299 url=http://localhost:8000/):default) has no stream matching stream PC:1603192415301092 (id=4294967299 url=http://localhost:8000/) transport-id=transport_0 - b250cb26:ca4ec7b0f566a2aaf4b1e062f03b0458

ICE(PC:1603192415299233 (id=4294967299 url=http://localhost:8000/)): peer (PC:1603192415299233 (id=4294967299 url=http://localhost:8000/):default) has no stream matching stream PC:1603192415299233 (id=4294967299 url=http://localhost:8000/) transport-id=transport_0 - 3c9d1753:e62bb42ab019ad3fdb785f8569330855

ICE(PC:1603192415299233 (id=4294967299 url=http://localhost:8000/)): peer (PC:1603192415299233 (id=4294967299 url=http://localhost:8000/):default) has no stream matching stream PC:1603192415299233 (id=4294967299 url=http://localhost:8000/) transport-id=transport_1 - 3c9d1753:e62bb42ab019ad3fdb785f8569330855

+++++++ END ++++++++
```

I have also tried setting `media.peerconnection.ice.loopback` to `true` with no luck.