const driver = require("geckodriver");
const express = require("express");
const server = express();
server.use("/", express.static(__dirname + "/app"));
server.listen(8000);


const { remote } = require("webdriverio");

(async () => {
  await driver.start();
  const browser = await remote({
    logLevel: "trace",
    maxInstances: 1,
    runner: "local",
    automationProtocol: "webdriver",
    capabilities: {
      browserName: "firefox",
      "moz:firefoxOptions": {
        // args: ["-headless"], // https://github.com/webdriverio/webdriverio/issues/2528#issuecomment-354429355
        prefs: {
          "browser.cache.disk.enable": false,
          "browser.cache.disk.capacity": 0,
          "browser.cache.disk.smart_size.enabled": false,
          "browser.cache.disk.smart_size.first_run": false,
          "browser.sessionstore.resume_from_crash": false,
          "browser.startup.page": 0,
          "media.navigator.streams.fake": true,
          "media.navigator.permission.disabled": true,
          "device.storage.enabled": false,
          "media.gstreamer.enabled": false,
          "browser.startup.homepage": "about:blank",
          "browser.startup.firstrunSkipsHomepage": false,
          "extensions.update.enabled": false,
          "app.update.enabled": false,
          "network.http.use-cache": false,
          "browser.shell.checkDefaultBrowser": false,
        },
      },
    },
  });

  await browser.url("http://localhost:8000");
})().catch((e) => console.error(e));
